# -*- coding: latin-1 -*-

""" Parcours infixe d'arbre binaire par un gnrateur """

# Pour ceux qui auraient de la peine  suivre ce qui se passe:
# prenez le temps d'installer le debugger Winpdb:
# http://winpdb.org/download/
# et de tracer trs prcisment ce qui se passe, jusqu' ce que
# tout soit clair...

def inorder(t):
	if t.left:
		for i in inorder(t.left): 
			yield i
	yield t.name
	if t.right: 
		for i in inorder(t.right): 
			yield i

class Tree:
	def __init__(self, name, left=None, right=None):
		self.name = name
		self.left = left
		self.right = right
		
	# Les deux mthode de reprsentation n'taient pas demandes,
	# mais elles peuvent aider pour le debug
		
	def __repr__(self):
		""" Reprsentation compacte. Utile pour le debug """
		return "<Subtree with root '%s'>" % self.name
		
	def __str__(self, prefix = ""):
		""" Reprsentation rcrursive sous forme "d'arbre ASCII" """
		result = "%s%s\n" % (prefix, self.name)
		prefix += '. '
		for c in [child for child in [self.left, self.right] if child]:
			result += c.__str__(prefix)
		return result
			
	
if __name__ == "__main__":

	t = Tree('0',
		Tree('l',
			Tree('ll'),
			Tree('lr')
		),
		Tree('r',
			Tree('rl',
				Tree('rll'),
				Tree('rlr')
			),
			Tree('rr',
				Tree('rrl'),
				Tree('rrr')
			)
		)
	)

	for i in inorder(t):
		print "Next node in in-order:",
		print i