# -*- coding: latin-1 -*-

""" Gestionnaire de contexte faisant un simple log des erreurs  la console """

from __future__ import with_statement
from contextlib import contextmanager
import sys

@contextmanager
def error_catcher():
	try:
		yield
	except:
		type, value, traceback = sys.exc_info()
		# On dpile l'appel de error_catcher pour avoir une meilleure information:
		traceback = traceback.tb_next
		print "*** An error occurred in line %d!" % traceback.tb_lineno
		print "***     type:   ", type
		print "***     error:  ", value
		
if __name__ == '__main__':
		
	print "Let's go!"

	with error_catcher():
		for i in range(3,-1,-1):
			print 1.0/i
		
	print "The End!"